defval jtlag 12//nombre de pas de temps Delta t/ delta t
defval nlon 87 //nbre de points de grilles en longitude
defval nlat 58 //nbre de points de grilles en latitude
defval nfloat 1 //nbre de flotteurs

hat_name "floater.h"



option o_m1qn3
option o_gradtest
//option  O_EXTOBJ "../object/ncutil.o" //for aviso files

//    name   M upt offt  dt    nbstep
traj T_float M 1    0     1    jtlag //trajectoire pour r 
traj T_euler M 0    0     1    1 //trajectoire pour u et v

//deltas
traj T_float_d D 1    0     1    jtlag //trajectoires type modele ou tangent. permet de controler quel type activer dans le i
traj T_euler_d  D 0    0     1    1 

space S_float M nfloat    T_float
space S_euler M nlon nlat T_euler
space S_eulerlocate M nfloat nlon nlat T_float

//deltas
space S_float_d M nfloat    T_float_d
space S_euler_d M nlon nlat T_euler_d
space S_eulerlocate_d M nfloat nlon nlat T_float_d


modul r_float space S_float input 4  output 2 tempo 
modul ur      space S_float input 18 output 2 tempo
modul uinter space S_float noward   output 8 tempo
modul xinter space S_float noward   output 8 tempo

modul u       space S_euler noward   output 1  //noward veut dire pas de calcul
modul v		  space S_euler noward   output 1 
modul locate  space S_eulerlocate input 2  output 1 tempo

//deltas
modul r_float_d space S_float_d input 4  output 2 tempo 
modul ur_d      space S_float_d input 18 output 2 tempo
modul uinter_d space S_float_d noward   output 8 tempo
//modul xinter_d space S_float_d noward   output 8 tempo

modul u_d       space S_euler_d noward   output 1 target //noward veut dire pas de calcul
modul v_d		  space S_euler_d noward   output 1 target
modul locate_d  space S_eulerlocate_d input 2  output 1 tempo
modul r_cout_d space S_float_d input 2  output 2 tempo cout




exec disp_modul //afficher les modules lors de la ganeration du code

ctin r_float  1..2   from r_float 1..2 i t-1 // i par default est la premier dimension, ici i=1 floater
ctin r_float  3..4   from ur      1..2 i t    // comme c'est un calcul, il depend pas de la valeur initiale

ctin ur       1..8   from uinter 1..8 i t
ctin ur       9..16  from xinter 1..8 i t
ctin ur       17..18 from r_float 1..2 i t-1

ctin locate   1..2   from r_float 1..2 i t-1

//deltas
ctin r_float_d  1..2   from r_float_d 1..2 i t-1 // i par default est la premier dimension, ici i=1 floater
ctin r_float_d  3..4   from ur_d      1..2 i t    // comme c'est un calcul, il depend pas de la valeur initiale

ctin ur_d       1..8   from uinter_d 1..8 i t
ctin ur_d       9..16  from xinter 1..8 i t
ctin ur_d       17..18 from r_float 1..2 i t-1

ctin locate_d   1..2   from r_float_d 1..2 i t-1
ctin r_cout_d   1..2   from r_float_d 1..2 i t       

exec disp_ct_in //afficher les connexions

order modinspace S_float
	order YA1
		ur r_float
	forder
forder

order modinspace S_eulerlocate
	order YA1 YA2 YA3
		locate
	forder
forder

order spaceintraj T_float
	S_eulerlocate S_float
forder
 
//deltas
order modinspace S_float_d
	order YA1
		ur_d r_float_d r_cout_d
	forder
forder

order modinspace S_eulerlocate_d
	order YA1 YA2 YA3
		locate_d
	forder
forder

order spaceintraj T_float_d
	S_eulerlocate_d S_float_d
forder
 
 
//insert_fct arg load_aviso
insert_fct update_uv
insert_fct arg run_inc

